package org.processmining.causalactivitygraphcreator.algorithms;

import org.deckfour.xes.model.XLog;
import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.causalactivitygraphcreator.parameters.DiscoverCausalActivityGraphParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrixminer.algorithms.DiscoverFromEventLogAlgorithm;
import org.processmining.framework.plugin.PluginContext;

public class DiscoverCausalActivityGraphAlgorithm {

	public CausalActivityGraph apply(PluginContext context, XLog log,
			DiscoverCausalActivityGraphParameters parameters) {
		DiscoverFromEventLogAlgorithm discoverer = new DiscoverFromEventLogAlgorithm();
		CausalActivityMatrix matrix = discoverer.apply(context, log, parameters.getDiscoverParameters());
		ConvertCausalActivityMatrixToCausalActivityGraphAlgorithm converter = new ConvertCausalActivityMatrixToCausalActivityGraphAlgorithm();
		return converter.apply(context, matrix, parameters);
	}
}
