package org.processmining.causalactivitygraphcreator.algorithms;

import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.causalactivitygraphcreator.creators.GraphCreator;
import org.processmining.causalactivitygraphcreator.creators.GraphCreatorManager;
import org.processmining.causalactivitygraphcreator.creators.GraphCreatorParameters;
import org.processmining.causalactivitygraphcreator.parameters.GraphCreatorsParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.framework.plugin.PluginContext;

public class GraphCreatorsAlgorithm {

	public CausalActivityGraph apply(PluginContext context, CausalActivityMatrix matrix,
			GraphCreatorsParameters parameters) {
		GraphCreator creator = GraphCreatorManager.getInstance().getCreator(parameters.getCreator());
		GraphCreatorParameters creatorParameters = new GraphCreatorParameters(parameters);
		return creator.apply(context, matrix, creatorParameters);
	}
}
