package org.processmining.causalactivitygraphcreator.creators.impl;

import java.util.HashSet;
import java.util.List;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.causalactivitygraph.models.impl.CausalActivityGraphFactory;
import org.processmining.causalactivitygraphcreator.creators.GraphCreator;
import org.processmining.causalactivitygraphcreator.creators.GraphCreatorParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.framework.plugin.PluginContext;

public class GraphZeroCreator implements GraphCreator {

	public final static String NAME = "Values Exceeding Zero";
	
	public CausalActivityGraph apply(PluginContext context, CausalActivityMatrix matrix,
			GraphCreatorParameters parameters) {
		CausalActivityGraph graph = CausalActivityGraphFactory.createCausalActivityGraph();
		List<XEventClass> activities = matrix.getActivities();
		graph.init(matrix.getLabel(), new HashSet<XEventClass>(activities));
		for (XEventClass rowActivity : activities) {
			for (XEventClass columnActivity : activities) {
				double value = matrix.getValue(rowActivity, columnActivity);
				if (value > 0.0) {
					graph.setCausality(rowActivity, columnActivity, value);
				}
			}
		}
		return graph;
	}

	public String getName() {
		return NAME;
	}

}
