package org.processmining.causalactivitygraphcreator.dialogs;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.Dimension;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.causalactivitygraphcreator.parameters.GraphCreatorsParameters;
import org.processmining.framework.util.ui.widgets.ProMList;

public class CreatorPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6196587510149546778L;

	public CreatorPanel(List<String> creators, final GraphCreatorsParameters creatorsParameters) {
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL } };
		setLayout(new TableLayout(size));

		setOpaque(false);
		
		DefaultListModel<String> listModel = new DefaultListModel<String>();
		for (String creator: creators) {
			listModel.addElement(creator);
		}
		final ProMList<String> list = new ProMList<String>("Select creator", listModel);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		final String defaultCreator = creatorsParameters.getCreator();
		list.setSelection(defaultCreator);
		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				List<String> selected = list.getSelectedValuesList();
				if (selected.size() == 1) {
					creatorsParameters.setCreator(selected.get(0));
				} else {
					/*
					 * Nothing selected. Revert to selection of default classifier.
					 */
					list.setSelection(defaultCreator);
					creatorsParameters.setCreator(defaultCreator);
				}
			}
		});
		list.setPreferredSize(new Dimension(100, 100));
		add(list, "0, 0");

	}
}
