package org.processmining.causalactivitygraphcreator.parameters;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.causalactivitymatrixminer.parameters.DiscoverFromEventLogParameters;
import org.processmining.log.parameters.ClassifierParameter;
import org.processmining.log.parameters.MinerParameter;

public class DiscoverCausalActivityGraphParameters extends ConvertCausalActivityMatrixToCausalActivityGraphParameters implements ClassifierParameter, MinerParameter {

	private DiscoverFromEventLogParameters discoverParameters;
	private boolean useDot;
	
	public DiscoverCausalActivityGraphParameters(XLog log) {
		super();
		discoverParameters = new DiscoverFromEventLogParameters(log);
		useDot = true;
	}

	public DiscoverCausalActivityGraphParameters(DiscoverCausalActivityGraphParameters parameters) {
		super(parameters);
		discoverParameters = new DiscoverFromEventLogParameters(parameters.getDiscoverParameters());
		useDot = parameters.useDot;
	}
	
	public boolean equals(Object object) {
		if (object instanceof DiscoverCausalActivityGraphParameters) {
			DiscoverCausalActivityGraphParameters parameters = (DiscoverCausalActivityGraphParameters) object;
			return super.equals(parameters) && discoverParameters.equals(parameters.discoverParameters);
		}
		return false;
	}

	public DiscoverFromEventLogParameters getDiscoverParameters() {
		return discoverParameters;
	}
	
	public void setMiner(String miner) {
		discoverParameters.setMiner(miner);
	}

	public String getMiner() {
		return discoverParameters.getMiner();
	}

	public void setClassifier(XEventClassifier classifier) {
		discoverParameters.setClassifier(classifier);
	}
	
	public XEventClassifier getClassifier() {
		return discoverParameters.getClassifier();
	}
	
	public boolean isShowClassifierPanel() {
		return discoverParameters.isShowClassifierPanel();
	}
	public void setShowClassifierPanel(boolean showClassifierPanel) {
		discoverParameters.setShowClassifierPanel(showClassifierPanel);
	}

	public boolean isUseDot() {
		return useDot;
	}

	public void setUseDot(boolean useDot) {
		this.useDot = useDot;
	}
}
